<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               :upload-after="uploadAfter"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.payments_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/platform/payments";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          labelWidth: 120,
          column: [
            {
              label: "主键ID",
              prop: "id",
              hide: true,
              addDisplay: false,
              editDisabled: true,
              rules: [{
                required: true,
                message: "请输入主键ID",
                trigger: "blur"
              }]
            },
            {
              label: "支付code",
              prop: "payCode",
              rules: [{
                required: true,
                message: "请输入支付code",
                trigger: "blur"
              }]
            },
            {
              label: "支付方式名称",
              prop: "payName",
              rules: [{
                required: true,
                message: "请输入支付方式名称",
                trigger: "blur"
              }]
            },
            {
              label: "排序",
              prop: "sort",
              rules: [{
                required: true,
                message: "请输入排序",
                trigger: "blur"
              }]
            },
            {
              label: "参数配置",
              prop: "payConfig",
              rules: [{
                required: true,
                message: "请输入参数配置",
                trigger: "blur"
              }]
            },
            {
              label: "是否启用",
              prop: "isEnabledDisplayName",
              display: false,
            },
            {
              label: "是否启用",
              prop: "isEnabled",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请选择是否启用",
                trigger: "blur"
              }]
            },
            {
              label: "是否在线支付",
              prop: "isOnlineDisplayName",
              display: false,
            },
            {
              label: "是否在线支付",
              prop: "isOnline",
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请选择是否在线支付",
                trigger: "blur"
              }]
            },
            {
              label: "支付端标识",
              prop: "payForDisplayName",
              display: false,
            },
            {
              label: "支付端标识",
              prop: "payFor",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=pay_for",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
              search: true,
              hide: true,
              addDisplay: false,
              rules: [{
                required: true,
                message: "请选择支付端标识",
                trigger: "blur"
              }]
            },
            {
              label: "支付方式描述",
              prop: "payDesc",
              span: 24,
              rules: [{
                required: true,
                message: "请输入支付方式描述",
                trigger: "blur"
              }]
            },
            {
              label: "支付图标",
              prop: "payImg",
              type: 'upload',
              addDisplay: false,
              editDisplay: false,
              listType: 'picture-img',
              span: 24,
              drag: true,
            },
            {
              label: '支付图标',
              prop: 'attachUrl',
              type: 'upload',
              drag: true,
              listType: 'picture-img',
              loadText: '模板上传中，请稍等',
              span: 24,
              hide: true,
              viewDisplay: false,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.payments_add, false),
          viewBtn: this.vaildData(this.permission.payments_view, false),
          delBtn: this.vaildData(this.permission.payments_delete, false),
          editBtn: this.vaildData(this.permission.payments_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      uploadAfter(res, done, loading, column) {
        this.form.payImg = res.link;
        done()
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
